% v4.0. Not returning mb,ms and cb. No wait bar.
function [MCbMCs,cs]=CIE_Method1(im,mask,Cb,Cs)

    indx=find(mask);
    r=im(:,:,1);
    g=im(:,:,2);
    b=im(:,:,3);
    imRGB=[r(indx) g(indx) b(indx)];

    thr=0;
    for s=1:size(Cs,1)
        [mbx msx]=solveMbMsPositive(imRGB,Cb(1,:),Cs(s,:));
        mcbmcs = mbx' * Cb(1,:) + msx' * Cs(s,:);
        eReconst=sum(sum((imRGB-mcbmcs).^2))/size(im(:),1);

        ERs=eReconst;
        MSs=sum(msx(:))/sum(mask(:));
        if MSs/ERs>thr
            thr=MSs/ERs;
            cs=Cs(s,:);
            MCbMCsx=mcbmcs;
        end
    end
    MCbMCs=zeros(size(im,1)*size(im,2),3);
    MCbMCs(indx,:)=MCbMCsx;
    MCbMCs=reshape(MCbMCs,size(im,1),size(im,2),3);
    
end
