% Reduction of the CIE_Method to just retrieve cs
function cs = CIE_Method3(im,mask,Cb,Cs)

    indx=find(mask);
    r=im(:,:,1);
    g=im(:,:,2);
    b=im(:,:,3);
    imRGB=[r(indx) g(indx) b(indx)];

    thr=0;
    for s=1:size(Cs,1)
        [mbx msx]=solveMbMsPositive(imRGB,Cb(1,:),Cs(s,:));
        mcbmcs = mbx' * Cb(1,:) + msx' * Cs(s,:);
        ERs=sum(sum((imRGB-mcbmcs).^2))/size(im(:),1);
        MSs=sum(msx(:))/sum(mask(:));
        
        if MSs/ERs>thr
            thr=MSs/ERs;
            cs=Cs(s,:);
        end
    end
    
end
