function [MbD2, MbS2, MsS] = recalculateMbMs(f,mask,dMask,MsD,LD,LS,Cb)

    c1=Cb.*LD;
    c2=Cb.*LS;
    c1=c1/norm(c1)*255;
    c2=c2/norm(c2)*255;

    ff=reshape(f.*repmat(mask,[1 1 3]),size(f,1)*size(f,2),3)-MsD(:)*LD;
    ff(ff<0)=0;
    M=ff/[c1;c2];
    MbD2=reshape(M(:,1),size(f,1), size(f,2));
    MbS2=reshape(M(:,2),size(f,1), size(f,2));

    sMask=sign(MbS2)<0;
    indx=find(sMask);
    b=ff(indx,:)';
    mx=pinv(c1')*b;
    MbD2(indx)=mx;
    MbS2(indx)=zeros(size(indx,1),1);

    sMask=sign(MbD2)<0;
    indx=find(sMask);
    b=ff(indx,:)';
    mx=pinv(c2')*b;
    MbS2(indx)=mx;
    MbD2(indx)=zeros(size(indx,1),1);

    % MsS=MsD.*logical(mask.*(~dMask));
    MsS=zeros(size(MsD));
    
end
